<?php
/**
* Builds route for JoomGallery
* http://www.joomgallery.net/
*
* components/com_joomgallery/router.php
* Version: 1.2.5.1b
* Date: 26.05.2010
*
** copy this file in directory /components/com_joomgallery/
*/

//Set the url params
function routerparams()  {
   $rparams = array();
   // force the router to use only this Itemid, example: 35
   //default: false
   $rparams['force_itemid'] = false;
   
   //language params
   $rparams['lastcomment'] = 'last commented pictures';
   $rparams['lastadd'] = 'last added pictures';
   $rparams['rating'] = 'best rated pictures';
   $rparams['hits'] = 'most viewed pictures';
   $rparams['userpanel'] = 'userpanel';
   
   $rparams['page'] = 'page'; //gallery and category pagination
   $rparams['space'] = '-'; //replace space in the url !!( do not use symbols that are in the categories name )!!
   
   
   $rparams['idbefore'] = false; //set false for make the id image after the name title
   //false = joomgallery/catname/imagename-idimage
   //true  = joomgallery/catname/idimage-imagename 
   
   
   //for not use the image id in the link, not use this in a multiuser gallery!!
   $rparams['noidintitle'] = true; //set true for not use the id in the image title
   //is not possible use $rparams['space'] symbols in the imagename
   //no 2 images can ave the same title in the same category!!!  is not possible replace special charset in the imagename
   
   
   return $rparams;
   
}
function replacespecial($string)  {  
    $replace = array(
        'Š'=>'S', 'š'=>'s', 'Ð'=>'Dj', 'Ž'=>'Z', 'ž'=>'z', 'C'=>'C', 'c'=>'c', 'C'=>'C', 'c'=>'c',
        'À'=>'A', 'Á'=>'A', 'Â'=>'A', 'Ã'=>'A', 'Ä'=>'A', 'Å'=>'A', 'Æ'=>'A', 'Ç'=>'C', 'È'=>'E', 'É'=>'E',
        'Ê'=>'E', 'Ë'=>'E', 'Ì'=>'I', 'Í'=>'I', 'Î'=>'I', 'Ï'=>'I', 'Ñ'=>'N', 'Ò'=>'O', 'Ó'=>'O', 'Ô'=>'O',
        'Õ'=>'O', 'Ö'=>'O', 'Ø'=>'O', 'Ù'=>'U', 'Ú'=>'U', 'Û'=>'U', 'Ü'=>'U', 'Ý'=>'Y', 'Þ'=>'B', 'ß'=>'Ss',
        'à'=>'a', 'á'=>'a', 'â'=>'a', 'ã'=>'a', 'ä'=>'a', 'å'=>'a', 'æ'=>'a', 'ç'=>'c', 'è'=>'e', 'é'=>'e',
        'ê'=>'e', 'ë'=>'e', 'ì'=>'i', 'í'=>'i', 'î'=>'i', 'ï'=>'i', 'ð'=>'o', 'ñ'=>'n', 'ò'=>'o', 'ó'=>'o',
        'ô'=>'o', 'õ'=>'o', 'ö'=>'o', 'ø'=>'o', 'ù'=>'u', 'ú'=>'u', 'û'=>'u', 'ü'=>'u','ý'=>'y', 'ý'=>'y',
        'ÿ'=>'y', 'R'=>'R', 'r'=>'r', 'þ'=>'b', 'а'=>'a', 'б'=>'b', 'в'=>'v', 'г'=>'g', 'д'=>'d', 'е'=>'e', 'ё'=>'yo',
		'ж'=>'zh', 'з'=>'z', 'и'=>'i', 'й'=>'j', 'і'=>'i', 'ї'=>'yi', 'к'=>'k', 'л'=>'l', 'м'=>'m', 'н'=>'n', 'о'=>'o', 'п'=>'p',
		'р'=>'r', 'с'=>'s', 'т'=>'t', 'у'=>'u', 'ф'=>'f', 'х'=>'h', 'ц'=>'tz', 'ч'=>'ch', 'ш'=>'sh', 'щ'=>'sch',
		'ы'=>'y','ю'=>'yu', 'я'=>'ya',
		'А'=>'a', 'Б'=>'b', 'В'=>'v', 'Г'=>'g', 'Д'=>'d', 'Е'=>'e', 'Ё'=>'yo', 'Ж'=>'zh', 'З'=>'z', 'И'=>'i', 'Й'=>'j', 'І'=>'i', 'Ї'=>'yi',
		'К'=>'k', 'Л'=>'l', 'М'=>'m', 'Н'=>'n', 'О'=>'o', 'П'=>'p', 'Р'=>'r', 'С'=>'s', 'Т'=>'t', 'У'=>'u',
		'Ф'=>'f', 'Х'=>'h', 'Ц'=>'tz', 'Ч'=>'ch', 'Ш'=>'sh', 'Щ'=>'sch', 'Ы'=>'y', 'Ю'=>'yu', 'Я'=>'ya'
    );
	//$string = utf8_decode($string);
	$string = strtr($string, $replace);
	$string = ereg_replace("[^A-Za-z0-9 ]", "", $string );
  //return  utf8_encode( $string );
	return strtolower($string);
}

function JoomgalleryBuildRoute(&$query)
{
 
	$segments	= array();
	$database 	  =& JFactory::getDBO();
	//router params
	$rparams = routerparams();
   if( $rparams['force_itemid'] == false ){
       if ( !isset($query['Itemid']) ) {
           // Get the active menu item.
           $menu   = &JSite::getMenu();
           $items  = $menu->getItems('link', 'index.php?option=com_joomgallery');
		   if( isset($items[0])){
			  $query['Itemid'] = $items[0]->id;
		   }
       }
    }else{
       $query['Itemid'] = $rparams['force_itemid'];
    }
	
	
    if ( isset($query['func']) ) {
	    
	
	    /*---------------------------------------------------------------------------*/
	    // Detail view	    
	    if( ($query['func'] == 'detail' || $query['func'] == 'watermark')  && isset($query['id'])  ) {
           $database->setQuery("SELECT catid, imgtitle FROM #__joomgallery WHERE id=". (int) $query['id']);
           $result = $database->loadObjectList();
           $img = $result[0];           
           $segments = joom_catpath($img->catid, $database);//cat name
           
           		   
		   //$imgtitle = $img->imgtitle;
		   
		   if( $rparams['noidintitle'] == false ){ //id in the image title
		       $imgtitle = replacespecial($img->imgtitle);
		   
		       if( $rparams['idbefore'] == true ){
		           $segments[] = $query['id'].' '.$imgtitle; //image name ( id + title )
		       }else{
			       $segments[] = $imgtitle.' '.$query['id']; //image name ( title + id )
		       }
		   }else{
			   //no id in the image title
			   $segments[] = replacespecial($img->imgtitle);
		   }
		   
          // if used watermark  
		      if ($query['func'] == 'watermark') {
              $segments[] = $query['orig'];
              $segments[] = $query['no_html'];
              $segments[] = $query['func'];
              unset( $query['catid'] );
              unset( $query['orig'] );
              unset( $query['no_html'] );
           }
		   
	       unset( $query['func'] );
	       unset( $query['id'] );
        }

        /*---------------------------------------------------------------------------*/
        // Category view
        // func=viewcategory, catid=$var1 
	    elseif ( $query['func'] == 'viewcategory' && isset($query['catid']) ) {
		
           $segments = joom_catpath($query['catid'], $database);
		  // print (urldecode($segments[0]));
	       unset( $query['func'] );
	       unset( $query['catid'] );
		   
		   //pagination
		   if ( isset($query['startpage']) ) {
              $segments[] = $rparams['page'].$query['startpage'];
			  unset( $query['startpage'] );
           }
	       if ( isset($query['substartpage']) ) {
                $segments[] = 'subpage'.$query['substartpage'];
				unset( $query['substartpage'] );
           }
		   
		    //orderby=date&orderdir=desc#category
	       if ( isset($query['orderby']) ) {
                $order = 'orderby'.$query['orderby'];
				unset( $query['orderby'] );
				if ( isset($query['orderdir']) ) {
                    $order .= ' '.$query['orderdir'];
				    unset( $query['orderdir'] );
                }
				$segments[] = $order;
           }
		  
	    }
		
	    /*---------------------------------------------------------------------------*/
        // Search results
        // func=special, sorting=find, $sstring=$var1
        elseif ($query['func'] == 'special' 
		       && isset( $query['sorting'] ) && $query['sorting'] == 'find'
			   && isset( $query['sstrin'] ) ) {
			   
          $segments[] = 'search';
		  $segments[] = $query['sstrin'];
		  unset( $query['func'] );
		  unset( $query['find'] );
		  unset( $query['sstrin'] );
        }
		
	    /*---------------------------------------------------------------------------*/
        // Toplists view
        // func=special, sorting=$var1
        elseif ( $query['func'] == 'special' ) {
           if ( isset( $query['sorting']  )) {
              $sorting = $query['sorting'];
              switch ($sorting) {
                 case "lastcomment" :
                    $segments[] = $rparams['lastcomment'];
                 break;
                 case "lastadd" :
                    $segments[] = $rparams['lastadd'];
                 break;
                 case "rating" :
                    $segments[] = $rparams['rating'];
                 break;
              }
			  unset( $query['sorting'] );
			  
           } else {
              $segments[] = $rparams['hits'];
           }
		   
           unset( $query['func'] ); 
       }
	   
	   /*---------------------------------------------------------------------------*/
       // Handle tasks that don't have parameters
       // variables: NULL
       elseif ($query['func'] == 'savepic'
	        || $query['func'] == 'showfavourites'
			|| $query['func'] == 'switchlayout'
			|| $query['func'] == 'removeall'
			|| $query['func'] == 'createzip'
			|| $query['func'] == 'newusercat'
			|| $query['func'] == 'showupload'
			|| $query['func'] == 'uploadhandler'
			|| $query['func'] == 'send2friends'
			|| $query['func'] == 'userpanel' ) {

           $segments[] = $query['func'] == 'userpanel' ? $rparams['userpanel'] : $query['func'];
  
		   unset( $query['func'] );	   
       }
	   
	   //---------------User Category 
       //  com_joomgallery&func=showusercats&uid=62
	   elseif ( $query['func'] == 'showusercats' ){
	      $segments[] = 'showusercats';
		  if( isset( $query['uid'] ) ){
		     $segments[] = $query['uid']; 
		 	unset( $query['uid'] );
		  }
		  unset( $query['func'] );	 
	   }
	   
	   //  com_joomgallery&amp;func=saveusercat&amp;catid=0
	   elseif ( $query['func'] == 'saveusercat' && isset( $query['catid'] ) ){
	      $segments[] = 'saveusercat';
		  $segments[] = $query['catid'];
		 
		  unset( $query['func'] );
		  unset( $query['catid'] );
	   }
	   
	   elseif( $query['func'] == 'removepicture' ) {
	      $segments[] = 'removepicture';
		   if( isset( $query['id'] ) ){
		     $segments[] = $query['id']; 
		 	unset( $query['id'] );
		  }
		  
          unset( $query['func'] );
	   }
	   
	   //delete comment
	   //com_joomgallery&func=deletecomment&cmtid=1
	   elseif( $query['func'] == 'deletecomment' ) {
	     $segments[] = 'deletecomment';
		 
		 if( isset( $query['cmtid'] ) ){
		     $segments[] = $query['cmtid']; 
		 	unset( $query['cmtid'] );
		  }
		  
	      unset( $query['func'] );
	   }
	   
	   //com_joomgallery&func=deletenameshield&npicid=468&nuserid=75
	   elseif( $query['func'] == 'deletenameshield' ) {
	     $segments[] = 'deletenameshield';
		 
		 if( isset( $query['npicid'] ) ){
		     $segments[] = $query['npicid']; 
		 	unset( $query['npicid'] );
		  }
	      if( isset( $query['nuserid'] ) ){
		     $segments[] = $query['nuserid']; 
		 	unset( $query['nuserid'] );
		  }
		  
	      unset( $query['func'] );
	   }
	   
	   //------- &func= with $id e $catid
	   //download add favourites
	   elseif( $query['func'] == 'download' || $query['func'] == 'addpicture' ) {
	      $segments[] = $query['func'];
		 
		  if( isset( $query['id'] ) ){
		     $segments[] = $query['id']; 
		 	unset( $query['id'] );
		  }
          if( isset( $query['catid'] ) ){
		    $segments[] = $query['catid']; 
		 	unset( $query['catid'] );
		  }
		 
		  unset( $query['func'] );
	   }
	   
	   //------- &func= with $uid e $id
	   //Edit pic   com_joomgallery&func=editpic&uid=62&id=468
	   //deletepic  com_joomgallery&func=deletepic&uid=62&id=1
       elseif( $query['func'] == 'editpic' || $query['func'] == 'deletepic' ) {

	      $segments[] = $query['func'];

		  if( isset( $query['uid'] ) ){
		     $segments[] = $query['uid']; //userid
		 	unset( $query['uid'] );
		  }
          if( isset( $query['id'] ) ){
		    $segments[] = $query['id']; //id image
		 	unset( $query['id'] );
		  }
		  
		  unset( $query['func'] );
	   }
	   
	   
    }else{
	  
	   /*---------------------------------------------------------------------------*/
       // Gallery pagination
       if ( isset( $query['startpage'] ) ) {
          $segments[] = $rparams['page'].$query['startpage'];
		  unset( $query['startpage'] );
       }
	   
	   //double homepage?? /images.html  images.html?view=gallery
	   if( isset( $query['view'] ) ) unset( $query['view'] );
	  
	}

   // replace space with " - " and encode url
    
   $segments = str_replace(' ', $rparams['space'], $segments);
   foreach($segments as $segment){
     $segment = urlencode( strtolower( utf8_decode( $segment ) ) );
   }
  
   return $segments;
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////
/**
* Method to parse Route
* @param array $segments
*/
function JoomgalleryParseRoute($segments)
{

   $vars = array();
   
   //router params
   $rparams = routerparams();
   
   $count = count($segments);

   //decode url
   foreach($segments as $segment){
     $segment = utf8_encode( urldecode( $segment ) );
   }
   $segments = str_replace(':', ' ', $segments);
   $segments = str_replace($rparams['space'], ' ', $segments);
   
   /*find the Itemid*/
   if( $rparams['force_itemid'] == false ){   
      // Get the active menu item.
      $menu   = &JSite::getMenu();
      $item   = &$menu->getActive();
      //if no active menu search the itemid
      if ( !is_array($item) ){
        $items  = $menu->getItems('link', 'index.php?option=com_joomgallery');
		if( isset($items[0])) $vars['Itemid'] = $items[0]->id;
      }
   }else{
      $vars['Itemid'] = $rparams['force_itemid'];
   }

  //print_r($segments);  
   if( isset( $segments[0] ) && $segments[0] != '' ) {   
   
      /*---------------------------------------------------------------------------*/
      // description: handle toplist pages
      // variables: func=special, sorting=$var1
      if ( $segments[0] == $rparams['lastcomment']
        || $segments[0] == $rparams['lastadd']
        || $segments[0] == $rparams['rating']
        || $segments[0] == $rparams['hits'] ) {
		
        switch ($segments[0]) {
          case $rparams['lastcomment']:
			$vars['sorting'] = "lastcomment";
          break;
          case $rparams['lastadd']:
			$vars['sorting'] = "lastadd";
          break;
          case $rparams['rating']:
			$vars['sorting'] = "rating";
          break;
        }
		
        $vars['func'] = 'special';
        return $vars;
      }
	  
      // Search results
      elseif ( $segments[0] == "search" ) {
         $vars['func'] = 'special';
         $vars['sorting'] = 'find';
		 if( isset( $segments[1] ) ){
	        $vars['$sstring'] = $segments[1];
         }
         return $vars;
      }
	  
	  // user related pages
      elseif ($segments[0] == 'savepic' ||
		      $segments[0] == 'showfavourites' ||
              $segments[0] == 'switchlayout' ||
              $segments[0] == 'removeall' ||
		      $segments[0] == 'createzip' ||
		      $segments[0] == 'newusercat' ||
              $segments[0] == 'showupload' ||
              $segments[0] == 'uploadhandler' ||
              $segments[0] == 'send2friend' ||
              $segments[0] == 'control_panel' ||
              $segments[0] == 'userpanel' ) {
		
  
        $vars['func'] = $segments[0] == $rparams['userpanel'] ? 'userpanel' : $segments[0];
        return $vars;
      }
	  
	  //---------User category
      //  com_joomgallery&func=showusercats&uid=62
      
	  elseif ( $segments[0] =='showusercats' ) {
         $vars['func'] = 'showusercats';
		 if( isset( $segments[1] ) ){
           $vars['uid'] = $segments[1];
		 }
		 return $vars;
	  //  com_joomgallery&amp;func=saveusercat&amp;catid=0
	  }elseif( $segments[0] =='saveusercat' ) {
         $vars['func'] = 'saveusercat';
         $vars['catid'] = $segments[1];
		 return $vars;
	  }
	  
	  elseif($segments[0] =='removepicture') {
		$vars['func'] = 'removepicture';
        $vars['id'] = $segments[1];
		return $vars;
	  }
	  //delete comment
	  //com_joomgallery&func=deletecomment&cmtid=1
	  elseif( $segments[0] == 'deletecomment' ) {
	    $vars['func'] = 'deletecomment';
		$vars['cmtid'] =  $segments[1];

	  }
	  //com_joomgallery&func=deletenameshield&npicid=468&nuserid=75
	  elseif($segments[0] =='deletenameshield') {
		 $vars['func'] = 'deletenameshield';
         $vars['npicid'] = $segments[1];
         $vars['nuserid'] = $segments[2];
		 return $vars;
	  }
	
	  //&func with  catid e id
	  elseif ( $segments[0] =='download' || $segments[0] =='addpicture' ) {
         $vars['func'] = $segments[0];
         $vars['id'] = $segments[1];
		 if( isset($segments[2]) ){
           $vars['catid'] = $segments[2];
		 }
		 return $vars;
	  }
	  
	  //&func with  uid e id
	  elseif( $segments[0] =='editpic' || $segments[0] =='deletepic' ) {
         $vars['func'] = $segments[0];
         $vars['uid'] = $segments[1];
         $vars['id'] = $segments[2];
		 return $vars;
	  }
	  
	  /*---------------------------------------------------------------------------*/
      // Detail View or Category view
      // variables: func=detail or viewcategory or watermark, id=$var1
      else {
	  
	     //if only 1 segment and $rparams['page'] in the string is gallery pagination or category
		 $page_len = strlen($rparams['page']);
	     if( $count == 1 && substr($segments[0], 0, $page_len) == $rparams['page'] ) {
		 
		     $startpage= substr($segments[0], $page_len);
			 //if is number    is $startpage    
		     if( is_numeric($startpage) ){
                $vars['startpage'] = $startpage;
			 //else is a category name
			 }else{
			    $catid = joom_catid($segments, '0');
                if ($catid != null) {
                   $vars['func'] = 'viewcategory';
                   $vars['catid'] = $catid;
                }
			 }
		 
		 //if more segments is a subcategory or image
		 }else{
		 
		     //category pagination and orderby orderdir
			 $page_len = strlen($rparams['page']);
		     if(substr($segments[$count -1], 0, $page_len) == $rparams['page'] 
				|| substr($segments[$count -1], 0, 7) == 'orderby'
				|| substr($segments[$count -1], 0, 7) == 'subpage' ) {


			     if(substr($segments[$count -1], 0, 7) == 'orderby' ) {
				     $order = explode( ' ', substr($segments[$count -1], 7) );
				     $vars['orderby'] = $order[0];
					 if( isset($order[1]) ){
					    $vars['orderdir'] = $order[1] == 'asc' ? 'asc' : 'desc';
					 }
					 
				     unset( $segments[$count -1] );
				     $count = $count - 1;
			 
		         }
			     if(substr($segments[$count -1], 0, 7) == 'subpage' ) {
		             $startpage= substr($segments[$count -1], 7);
				     if( is_numeric($startpage) ){
				        $vars['substartpage'] = $startpage;
					    unset( $segments[$count -1] );
					    $count = $count - 1;
				     }
			 
		         }
			     $startpage= substr($segments[$count -1], $page_len);
				 if( is_numeric($startpage) ){
				    $vars['startpage'] = $startpage;
					unset( $segments[$count -1] );
					$count = $count - 1;
				 }
			 
		     }


		     $parent = $count == 1 ? '0' : '';
             $catid = joom_catid($segments, $parent);
             //if found id is category view
             if ($catid != null) {
                $vars['func'] = 'viewcategory';
                $vars['catid'] = $catid;
             } else {

                                      //Watermark
                     if (substr($segments[$count - 1], 0, 9) == 'watermark') {
                       $vars['func'] = 'watermark';
                       unset( $segments[$count - 1] );
                       $count = $count - 1;
                       if ( $segments[$count - 1] == '1' ) {
                           $vars['no_html'] = '1';
                           unset( $segments[$count - 1] );
                           $count = $count - 1;
                       }
                       if ( $segments[$count - 1] == '1' ) {
                           $vars['orig'] = '1';
                           unset( $segments[$count - 1] );
                           $count = $count - 1;
                       }
                     }


                //Detailview

		if( $rparams['noidintitle'] == false){ 
                //title id+ name
				
                    if( $rparams['idbefore'] == true ){
                        $imgid = explode( ' ', $segments[$count-1]);
		    }
                    else {
                        $imgid = array_reverse( explode( ' ', $segments[$count-1]) );
		    }


                    if ( $vars['func'] != 'watermark' )
                        $vars['func'] = 'detail';
                    $vars['id'] = $imgid[0];
		}

                if( !$rparams['idbefore'] || $vars['func'] == 'watermark'  ) {
                        //title only name
                        $database 	  =& JFactory::getDBO();
                        $catname = $segments[$count-2];
                        $database->setQuery("SELECT cid, name FROM #__joomgallery_catg");
                          $rows = $database->LoadObjectList('',false);
                        $rows = byname($rows,$catname);
                        $catid = $rows[0]->cid;



                    if (!isset($vars['id'])) {
                        $name =  $segments[$count-1] ;
                        $database->setQuery('SELECT id, imgtitle AS name FROM #__joomgallery WHERE catid='.$catid);
                             $rows = $database->LoadObjectList('',false);
                            $rows = byname($rows,$name);
                         $id = $rows[0]->id;
                        if($id) {

                       if ( $vars['func'] != 'watermark' )
                           $vars['func'] = 'detail';
                       else
                           $vars['catid'] = $catid;
                        $vars['id'] = $id;
                        }
                    }
                    else {
                        if ( $vars['func'] == 'watermark' )
                           $vars['catid'] = $catid;
                    }
		}
             }
	     }
         return $vars;
      }
	
	
   }//end if isset $segments[0]



return $vars;
}
////////////////////////////////////////////////////////////////////////////////////////////////////
// Functions
// Get category path for current item

function joom_catpath($catid, &$database) {
  $segments = array();
  $i = 0;
  while ( $catid != 0 ) {
    $database->setQuery("SELECT name, parent FROM #__joomgallery_catg WHERE cid=".(int) $catid);
    $category = $database->LoadObject();	
    $segments[$i] = $category->name;
    //$segments[$i] = utf8_decode($category->name); //must be commented for Cyrilic characters
    $segments[$i] = replacespecial($category->name); //extra line
    $catid = $category->parent;
    $i++;
  }
  if($i > 1) $segments = array_reverse($segments);
  return $segments;
}

// Get category id for current path
function joom_catid($segments, $parent='') {
  $database 	  =& JFactory::getDBO();
  $catid=0;
  $count = count($segments);
  $name = $segments[$count-1];
  $sql = "SELECT cid, parent, name FROM #__joomgallery_catg WHERE true";
  $sql .= $parent != '' ? ' AND parent='.$parent : '';
  $database->setQuery( $sql );
  $rows = $database->LoadObjectList('',false);
  $rows = byname($rows,$name);
  //if no result is a image
  if ( empty($rows) ) {
    return null;
	
  //if only 1 result is a category
  }elseif(count($rows) == 1 ) { 
    return $rows[0]->cid;
	
  //if more categories with same name is found
  } else {
    $z = $count-1;
    for ( $i=0; $i < $z ; $i++ ) {
       $temp_name = $database->Quote( $segments[$i] );
       $database->setQuery("SELECT cid "
                        ."FROM #__joomgallery_catg "
                        ."WHERE name=".$temp_name.""
                        ."AND parent=".(int) $catid);
       $temp_id = $database->loadResult(false);
       $catid = $temp_id;
    }
	foreach( $rows as $row ){
	  if( $row->parent == $catid ){
	     return $row->cid;
	  }
	}
  }
}


function byname($rows, $name) {
  $newrows = array();
  foreach ($rows as $row) {
    if (replacespecial($row->name) == $name) {
      $newrows[] = $row;
    }
  }
  return $newrows;;

}
?>